<template>
    <v-card color="grey lighten-5">
        <v-card-title>
            <v-btn
                @click="clear"
                :disabled="loading"
                color="white"
                small
            >{{ $t('clear') }}</v-btn>
            <v-spacer></v-spacer>
            <v-btn
                :disabled="loading"
                @click="$emit('confirmed')"
                color="primary"
                small
            >{{ $t('confirm') }}</v-btn>
        </v-card-title>
        <v-card-text>
            <v-list>
                <div v-if="loading" class="d-flex justify-center">
                    <v-progress-circular indeterminate color="primary"></v-progress-circular>
                </div>
                <v-list-group
                    v-else
                    v-for="selection in selections"
                    v-model="selection.active"
                    :key="selection.text"
                >
                    <template v-slot:activator>
                        <v-list-item-title>{{ selection.text }}</v-list-item-title>
                    </template>
                     <v-list-item-group
                        v-if="selection.field === 'type'"
                        v-model="selectedTypes"
                        multiple
                    >
                        <v-list-item
                            v-for="type in selectableTypes"
                            :key="type.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ type.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>
                </v-list-group>
            </v-list>
        </v-card-text>
    </v-card>
</template>

<script>
    export default {
        name: 'WishlistItemsFilters',
        props: [
            'types'
        ],
        data: () => ({
            loading: false,
            selectableTypes: [],
            selectedTypes: [],
        }),
        computed: {
            selections() {
                return [
                    {
                        text: this.$tc('type', 2),
                        field: 'type',
                        active: false
                    }
                ]
            }
        },
        watch: {
            selectedTypes(ids) {
                const map = ids.map(id => {
                    return this.selectableTypes[id].id
                });
                this.$emit('update:types', map);
            },
        },
        created() {
            this.loading = true;

            axios.get('api/products/types')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableTypes = data;
                })
                .catch(error => {
                    this.loading = false;
                })
        },
        methods: {
            clear() {
                this.selectedTypes = [];
                this.selections.forEach(selection => {
                    selection.active = false;
                })
            }
        }
    }
</script>

<style scoped>
</style>
